package ch.psi.daq.queryrest.response.csv;

import java.lang.reflect.Array;
import java.util.function.Function;

import ch.psi.daq.domain.DataEvent;

public class QueryFieldStringifyer implements Function<DataEvent, String> {
   public static final String OPEN_BRACKET = "[";
   public static final String CLOSE_BRACKET = "]";

   private Function<DataEvent, Object> accessor;
   private String nonValue;
   private String arraySeparator;

   public QueryFieldStringifyer(Function<DataEvent, Object> accessor, String nonValue, String arraySeparator) {
      this.accessor = accessor;
      this.nonValue = nonValue;
      this.arraySeparator = arraySeparator;
   }

   @Override
   public String apply(DataEvent event) {
      if (event == null) {
         return nonValue;
      }

      Object value = accessor.apply(event);
      if (value == null) {
         return nonValue;
      } else if (value.getClass().isArray()) {
         StringBuilder buf = new StringBuilder();

         int length = Array.getLength(value);
         buf.append(OPEN_BRACKET);
         for (int i = 0; i < length;) {
            buf.append(Array.get(value, i));

            ++i;
            if (i < length) {
               buf.append(arraySeparator);
            }
         }
         buf.append(CLOSE_BRACKET);

         return buf.toString();
      } else {
         return value.toString();
      }
   }
}
